Index: irc.c
===================================================================
--- irc.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ irc.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -526,336 +370,1168 @@
 	 */
 
-	cmd[0] = line;
-	for (i = 0, j = 0; line[i] != '\0'; i++) {
-		if (line[i] == ' ') {
-			line[i] = '\0';
-			cmd[++j] = line + i + 1;
-
-			if (line[i + 1] == ':') {
-				cmd[j]++;
+	cmd[0]=line;
+	for(i=0, j=0; line[i]!='\0'; i++) {
+		if((line[i]==32)) {
+			line[i]='\0';
+			if((line[i+1]!=32) && (line[i+1]!='\0') && (line[i+1]!=':')) 		
+				cmd[++j]=line+i+1;
+		}
+		else if((line[i]==':') && (line[i+1]!='\0') && (line[i-1]=='\0')) {
+			cmd[++j]=line+i+1;
+			break;
+		}
+	}
+	
+	i=irc_exec(irc, cmd);
+	g_free(cmd);
+
+	return(i);	
+}
+
+int irc_exec( irc_t *irc, char **cmd )
+{	
+	int i;
+
+	if( (global.conf)->authmode == AUTHMODE_CLOSED && irc->status < USTATUS_AUTHORIZED )
+	{
+		if( g_strcasecmp( cmd[0], "PASS" ) == 0 )
+		{
+			if( !cmd[1] )
+			{
+				irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+			}
+			else if( strcmp( cmd[1], (global.conf)->password ) == 0 )
+			{
+				irc->status = USTATUS_AUTHORIZED;
+			}
+			else
+			{
+				irc_reply( irc, 464, ":Nope, maybe you should try it again..." );
+			}
+		}
+		else
+		{
+			irc_reply( irc, 464, ":Uhh, fine, but I want the password first." );
+		}
+		
+		return( 1 );
+	}
+	
+	if( g_strcasecmp( cmd[0], "USER" ) == 0 )
+	{
+		if( !( cmd[1] && cmd[2] && cmd[3] && cmd[4] ) )
+		{
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+		}
+		else if( irc->user )
+		{
+			irc_reply( irc, 462, ":You can't change your nick/userinfo" );
+		}
+		else
+		{
+			irc->user = g_strdup( cmd[1] );
+			irc->realname = g_strdup( cmd[4] );
+			if( irc->nick ) irc_login( irc );
+		}
+		return( 1 );
+	}
+	else if( g_strcasecmp( cmd[0], "NICK" ) == 0 )
+	{
+		if( !cmd[1] )
+		{
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+		}
+		else if( irc->nick )
+		{
+			irc_reply( irc, 438, ":The hand of the deity is upon thee, thy nick may not change" );
+		}
+		/* This is not clean, but for now it'll have to be like this... */
+		else if( ( nick_cmp( cmd[1], irc->mynick ) == 0 ) || ( nick_cmp( cmd[1], NS_NICK ) == 0 ) )
+		{
+			irc_reply( irc, 433, ":This nick is already in use" );
+		}
+		else if( !nick_ok( cmd[1] ) )
+		{
+			/* [SH] Invalid characters. */
+			irc_reply( irc, 432, ":This nick contains invalid characters" );
+		}
+		else
+		{
+			irc->nick = g_strdup( cmd[1] );
+			if( irc->user ) irc_login( irc );
+		}
+		return( 1 );
+	}
+	
+	if( !irc->user || !irc->nick )
+	{
+		irc_reply( irc, 451, ":Register first" );
+		return( 1 );
+	}
+	
+	if( g_strcasecmp( cmd[0], "PING" ) == 0 )
+	{
+		irc_write( irc, ":%s PONG %s :%s", irc->myhost, irc->myhost, cmd[1]?cmd[1]:irc->myhost );
+	}
+	else if( g_strcasecmp( cmd[0], "MODE" ) == 0 )
+	{
+		if( !cmd[1] )
+		{
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+		}
+		else if( *cmd[1] == '#' )
+		{
+			if( cmd[2] )
+			{
+				if( *cmd[2] == '+' || *cmd[2] == '-' )
+					irc_reply( irc, 477, "%s :Can't change channel modes", cmd[1] );
+				else if( *cmd[2] == 'b' )
+					irc_reply( irc, 368, "%s :No bans possible", cmd[1] );
+			}
+			else
+				irc_reply( irc, 324, "%s +%s", cmd[1], CMODE );
+		}
+		else
+		{
+			if( nick_cmp( cmd[1], irc->nick ) == 0 )
+			{
+				if( cmd[2] )
+					irc_umode_set( irc, irc->nick, cmd[2] );
+			}
+			else
+				irc_reply( irc, 502, ":Don't touch their modes" );
+		}
+	}
+	else if( g_strcasecmp( cmd[0], "NAMES" ) == 0 )
+	{
+		irc_names( irc, cmd[1]?cmd[1]:irc->channel );
+	}
+	else if( g_strcasecmp( cmd[0], "PART" ) == 0 )
+	{
+		struct conversation *c;
+		
+		if( !cmd[1] )
+		{
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+		}
+		else if( g_strcasecmp( cmd[1], irc->channel ) == 0 )
+		{
+			user_t *u = user_find( irc, irc->nick );
+			
+			/* Not allowed to leave control channel */
+			irc_part( irc, u, irc->channel );
+			irc_join( irc, u, irc->channel );
+		}
+		else if( ( c = conv_findchannel( cmd[1] ) ) )
+		{
+			user_t *u = user_find( irc, irc->nick );
+			
+			irc_part( irc, u, c->channel );
+			
+			if( c->gc && c->gc->prpl )
+			{
+				c->joined = 0;
+				c->gc->prpl->chat_leave( c->gc, c->id );
+			}
+		}
+		else
+		{
+			irc_reply( irc, 403, "%s :No such channel", cmd[1] );
+		}
+	}
+	else if( g_strcasecmp( cmd[0], "JOIN" ) == 0 )
+	{
+		if( !cmd[1] )
+		{
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+		}
+		else if( g_strcasecmp( cmd[1], irc->channel ) == 0 )
+			; /* Dude, you're already there...
+			     RFC doesn't have any reply for that though? */
+		else if( cmd[1] )
+		{
+			if( cmd[1][0] == '#' && cmd[1][1] )
+			{
+				user_t *u = user_find( irc, cmd[1] + 1 );
+				
+				if( u && u->gc && u->gc->prpl && u->gc->prpl->chat_open )
+				{
+					irc_reply( irc, 403, "%s :Initializing groupchat in a different channel", cmd[1] );
+					
+					if( !u->gc->prpl->chat_open( u->gc, u->handle ) )
+					{
+						irc_usermsg( irc, "Could not open a groupchat with %s, maybe you don't have a connection to him/her yet?", u->nick );
+					}
+				}
+				else
+				{
+					irc_reply( irc, 403, "%s :Groupchats are not possible with %s", cmd[1], cmd[1]+1 );
+				}
+			}
+			else
+			{
+				irc_reply( irc, 403, "%s :No such channel", cmd[1] );
+			}
+		}
+	}
+	else if( g_strcasecmp( cmd[0], "INVITE" ) == 0 )
+	{
+		if( cmd[1] && cmd[2] )
+			irc_invite( irc, cmd[1], cmd[2] );
+		else
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+	}
+	else if( g_strcasecmp( cmd[0], "PRIVMSG" ) == 0 || g_strcasecmp( cmd[0], "NOTICE" ) == 0 )
+	{
+		if( !cmd[1] )
+		{
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+		} 
+		else if ( !cmd[2] ) 
+		{
+			irc_reply( irc, 412, ":No text to send" );
+		}
+		else if ( irc->nick && g_strcasecmp( cmd[1], irc->nick ) == 0 ) 
+		{
+			irc_write( irc, ":%s!%s@%s PRIVMSG %s :%s", irc->nick, irc->user, irc->host, cmd[1], cmd[2] ); 
+		}
+		else 
+		{
+			if( g_strcasecmp( cmd[1], irc->channel ) == 0 )
+			{
+				unsigned int i;
+				char *t = set_getstr( irc, "default_target" );
+				
+				if( g_strcasecmp( t, "last" ) == 0 && irc->last_target )
+					cmd[1] = irc->last_target;
+				else if( g_strcasecmp( t, "root" ) == 0 )
+					cmd[1] = irc->mynick;
+				
+				for( i = 0; i < strlen( cmd[2] ); i ++ )
+				{
+					if( cmd[2][i] == ' ' ) break;
+					if( cmd[2][i] == ':' || cmd[2][i] == ',' )
+					{
+						cmd[1] = cmd[2];
+						cmd[2] += i;
+						*cmd[2] = 0;
+						while( *(++cmd[2]) == ' ' );
+						break;
+					}
+				}
+				
+				irc->is_private = 0;
+				
+				if( cmd[1] != irc->last_target )
+				{
+					if( irc->last_target )
+						g_free( irc->last_target );
+					irc->last_target = g_strdup( cmd[1] );
+				}
+			}
+			else
+			{
+				irc->is_private = 1;
+			}
+			irc_send( irc, cmd[1], cmd[2], ( g_strcasecmp( cmd[0], "NOTICE" ) == 0 ) ? IM_FLAG_AWAY : 0 );
+		}
+	}
+	else if( g_strcasecmp( cmd[0], "QUIT" ) == 0 )
+	{
+		irc_write( irc, "ERROR :%s%s", cmd[1]?"Quit: ":"", cmd[1]?cmd[1]:"Client Quit" );
+		g_io_channel_close( irc->io_channel );
+		return( 0 );
+	}
+	else if( g_strcasecmp( cmd[0], "WHO" ) == 0 )
+	{
+		irc_who( irc, cmd[1] );
+	}
+	else if( g_strcasecmp( cmd[0], "USERHOST" ) == 0 )
+	{
+		user_t *u;
+		
+		if( !cmd[1] )
+		{
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+		}
+		/* [TV] Usable USERHOST-implementation according to
+			RFC1459. Without this, mIRC shows an error
+			while connecting, and the used way of rejecting
+			breaks standards.
+		*/
+		
+		for( i = 1; cmd[i]; i ++ )
+			if( ( u = user_find( irc, cmd[i] ) ) )
+			{
+				if( u->online && u->away )
+					irc_reply( irc, 302, ":%s=-%s@%s", u->nick, u->user, u->host );
+				else
+					irc_reply( irc, 302, ":%s=+%s@%s", u->nick, u->user, u->host );
+			}
+	}
+	else if( g_strcasecmp( cmd[0], "ISON" ) == 0 )
+	{
+		user_t *u;
+		char buff[IRC_MAX_LINE];
+		int lenleft;
+		
+		buff[0] = '\0';
+		
+		/* [SH] Leave room for : and \0 */
+		lenleft = IRC_MAX_LINE - 2;
+		
+		for( i = 1; cmd[i]; i ++ )
+		{
+			if( ( u = user_find( irc, cmd[i] ) ) && u->online )
+			{
+				/* [SH] Make sure we don't use too much buffer space. */
+				lenleft -= strlen( u->nick ) + 1;
+				
+				if( lenleft < 0 )
+				{
+					break;
+				}
+				
+				/* [SH] Add the nick to the buffer. Note
+				 * that an extra space is always added. Even
+				 * if it's the last nick in the list. Who
+				 * cares?
+				 */
+				
+				strcat( buff, u->nick );
+				strcat( buff, " " );
+			}
+		}
+		
+		/* [WvG] Well, maybe someone cares, so why not remove it? */
+		if( strlen( buff ) > 0 )
+			buff[strlen(buff)-1] = '\0';
+		
+		/* [SH] By the way, that really *was* WvG talking. */
+		/* [WvG] Really? */
+		/* [SH] Yeah... But *this* is WvG talking too. ;-P */
+		/* [WvG] *sigh* */
+		
+		irc_reply( irc, 303, ":%s", buff );
+	}
+	else if( g_strcasecmp( cmd[0], "WATCH" ) == 0 )
+	{
+		/* Obviously we could also mark a user structure as being
+		   watched, but what if the WATCH command is sent right
+		   after connecting? The user won't exist yet then... */
+		for( i = 1; cmd[i]; i ++ )
+		{
+			char *nick;
+			user_t *u;
+			
+			if( !cmd[i][0] || !cmd[i][1] )
 				break;
-			}
-		}
-	}
-
-	return cmd;
-}
-
-/* Converts such an array back into a command string. Mainly used for the IPC code right now. */
-char *irc_build_line(char **cmd)
-{
-	int i, len;
+			
+			nick = g_strdup( cmd[i] + 1 );
+			nick_lc( nick );
+			
+			u = user_find( irc, nick );
+			
+			if( cmd[i][0] == '+' )
+			{
+				if( !g_hash_table_lookup( irc->watches, nick ) )
+					g_hash_table_insert( irc->watches, nick, nick );
+				
+				if( u && u->online )
+					irc_reply( irc, 604, "%s %s %s %d :%s", u->nick, u->user, u->host, time( NULL ), "is online" );
+				else
+					irc_reply( irc, 605, "%s %s %s %d :%s", nick, "*", "*", time( NULL ), "is offline" );
+			}
+			else if( cmd[i][0] == '-' )
+			{
+				gpointer okey, ovalue;
+				
+				if( g_hash_table_lookup_extended( irc->watches, nick, &okey, &ovalue ) )
+				{
+					g_free( okey );
+					g_hash_table_remove( irc->watches, okey );
+					
+					irc_reply( irc, 602, "%s %s %s %d :%s", nick, "*", "*", 0, "Stopped watching" );
+				}
+			}
+		}
+	}
+	else if( g_strcasecmp( cmd[0], "TOPIC" ) == 0 )
+	{
+		if( cmd[1] && cmd[2] )
+			irc_reply( irc, 482, "%s :Cannot change topic", cmd[1] );
+		else if( cmd[1] )
+			irc_topic( irc, cmd[1] );
+		else
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+	}
+	else if( g_strcasecmp( cmd[0], "AWAY" ) == 0 )
+	{
+		irc_away( irc, cmd[1] );
+	}
+	else if( g_strcasecmp( cmd[0], "WHOIS" ) == 0 )
+	{
+		if( cmd[1] )
+		{
+			irc_whois( irc, cmd[1] );
+		}
+		else
+		{
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+		}
+	}
+	else if( g_strcasecmp( cmd[0], "WHOWAS" ) == 0 )
+	{
+		/* For some reason irssi tries a whowas when whois fails. We can
+		   ignore this, but then the user never gets a "user not found"
+		   message from irssi which is a bit annoying. So just respond
+		   with not-found and irssi users will get better error messages */
+		
+		if( cmd[1] )
+		{
+			irc_reply( irc, 406, "%s :Nick does not exist", cmd[1] );
+			irc_reply( irc, 369, "%s :End of WHOWAS", cmd[1] );
+		}
+		else
+		{
+			irc_reply( irc, 461, "%s :Need more parameters", cmd[0] );
+		}
+	}
+	else if( ( g_strcasecmp( cmd[0], "NICKSERV" ) == 0 ) || ( g_strcasecmp( cmd[0], "NS" ) == 0 ) )
+	{
+		/* [SH] This aliases the NickServ command to PRIVMSG root */
+		/* [TV] This aliases the NS command to PRIVMSG root as well */
+		root_command( irc, cmd + 1 );
+	}
+	else if( g_strcasecmp( cmd[0], "MOTD" ) == 0 )
+	{
+		irc_motd( irc );
+	}
+	else if( g_strcasecmp( cmd[0], "PONG" ) == 0 )
+	{
+		/* We could check the value we get back from the user, but in
+		   fact we don't care, we're just happy he's still alive. */
+		irc->last_pong = gettime();
+		irc->pinging = 0;
+	}
+	else if( g_strcasecmp( cmd[0], "COMPLETIONS" ) == 0 )
+	{
+		user_t *u = user_find( irc, irc->mynick );
+		help_t *h;
+		set_t *s;
+		int i;
+		
+		irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS ", "OK" );
+		
+		for( i = 0; commands[i].command; i ++ )
+			irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS ", commands[i].command );
+		
+		for( h = global.help; h; h = h->next )
+			irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS help ", h->string );
+		
+		for( s = irc->set; s; s = s->next )
+			irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS set ", s->key );
+		
+		irc_privmsg( irc, u, "NOTICE", irc->nick, "COMPLETIONS ", "END" );
+	}
+	else if( set_getint( irc, "debug" ) )
+	{
+		irc_usermsg( irc, "\002--- Unknown command:" );
+		for( i = 0; cmd[i]; i ++ ) irc_usermsg( irc, "%s", cmd[i] );
+		irc_usermsg( irc, "\002--------------------" );
+	}
+	
+	return( 1 );
+}
+
+void irc_reply( irc_t *irc, int code, char *format, ... )
+{
+	char text[IRC_MAX_LINE];
+	va_list params;
+	
+	va_start( params, format );
+	g_vsnprintf( text, IRC_MAX_LINE, format, params );
+	va_end( params );
+	irc_write( irc, ":%s %03d %s %s", irc->myhost, code, irc->nick?irc->nick:"*", text );
+	
+	return;
+}
+
+int irc_usermsg( irc_t *irc, char *format, ... )
+{
+	char text[1024];
+	va_list params;
+	char is_private = 0;
+	user_t *u;
+	
+	u = user_find( irc, irc->mynick );
+	if( u ) is_private = u->is_private;
+	
+	va_start( params, format );
+	g_vsnprintf( text, sizeof( text ), format, params );
+	va_end( params );
+	
+	return( irc_msgfrom( irc, u->nick, text ) );
+}
+
+void irc_write( irc_t *irc, char *format, ... ) 
+{
+	va_list params;
+
+	va_start( params, format );
+	irc_vawrite( irc, format, params );	
+	va_end( params );
+
+	return;
+
+}
+
+void irc_vawrite( irc_t *irc, char *format, va_list params )
+{
+	int size;
+	char line[IRC_MAX_LINE];
+	
+	if( irc->quit )
+		return;
+
+	g_vsnprintf( line, IRC_MAX_LINE - 3, format, params );
+
+	strip_newlines( line );
+	strcat( line, "\r\n" );
+
+	if( irc->sendbuffer != NULL ) {
+		size = strlen( irc->sendbuffer ) + strlen( line );
+#ifdef FLOOD_SEND
+		if( size > FLOOD_SEND_MAXBUFFER ) {
+			/* Die flooder, die! >:) */
+
+			g_free(irc->sendbuffer);
+			
+			/* We need the \r\n at the start because else we might append our string to a half
+			 * sent line. A bit hackish, but it works.
+			 */
+			irc->sendbuffer = g_strdup( "\r\nERROR :Sendq Exceeded\r\n" );
+			irc->quit = 1;
+			
+			return;
+		}
+#endif
+		irc->sendbuffer = g_renew ( char, irc->sendbuffer, size + 1 );
+		strcpy( ( irc->sendbuffer + strlen( irc->sendbuffer ) ), line );
+	}
+	else 
+		irc->sendbuffer = g_strdup(line);	
+	
+	if( irc->w_watch_source_id == 0 )
+	{
+		irc->w_watch_source_id = g_io_add_watch( irc->io_channel, G_IO_OUT, bitlbee_io_current_client_write, irc );
+	}
+	
+	return;
+}
+
+void irc_write_all( char *format, ... )
+{
+	va_list params;
+	GSList *temp;	
+
+	va_start( params, format );
+
+	temp = irc_connection_list;
+	while( temp!=NULL ) {
+		irc_vawrite( temp->data, format, params );
+		temp = temp->next;
+	}
+
+	va_end( params );
+	return;
+} 
+
+void irc_names( irc_t *irc, char *channel )
+{
+	user_t *u = irc->users;
 	char *s;
-
-	if (cmd[0] == NULL) {
-		return NULL;
-	}
-
-	len = 1;
-	for (i = 0; cmd[i]; i++) {
-		len += strlen(cmd[i]) + 1;
-	}
-
-	if (strchr(cmd[i - 1], ' ') != NULL) {
-		len++;
-	}
-
-	s = g_new0(char, len + 1);
-	for (i = 0; cmd[i]; i++) {
-		if (cmd[i + 1] == NULL && strchr(cmd[i], ' ') != NULL) {
-			strcat(s, ":");
-		}
-
-		strcat(s, cmd[i]);
-
-		if (cmd[i + 1]) {
-			strcat(s, " ");
-		}
-	}
-	strcat(s, "\r\n");
-
-	return s;
-}
-
-void irc_write(irc_t *irc, char *format, ...)
-{
-	va_list params;
-
-	va_start(params, format);
-	irc_vawrite(irc, format, params);
-	va_end(params);
-
-	return;
-}
-
-void irc_write_all(int now, char *format, ...)
-{
-	va_list params;
-	GSList *temp;
-
-	va_start(params, format);
-
-	temp = irc_connection_list;
-	while (temp != NULL) {
-		irc_t *irc = temp->data;
-
-		if (now) {
-			g_string_assign(irc->sendbuffer, "\r\n");
-		}
-		irc_vawrite(temp->data, format, params);
-		if (now) {
-			bitlbee_io_current_client_write(irc, irc->fd, B_EV_IO_WRITE);
-		}
-		temp = temp->next;
-	}
-
-	va_end(params);
-	return;
-}
-
-void irc_vawrite(irc_t *irc, char *format, va_list params)
-{
-	char line[IRC_MAX_LINE + 1];
-
-	/* Don't try to write anything new anymore when shutting down. */
-	if (irc->status & USTATUS_SHUTDOWN) {
-		return;
-	}
-
-	memset(line, 0, sizeof(line));
-	g_vsnprintf(line, IRC_MAX_LINE - 2, format, params);
-	strip_newlines(line);
-
-	if (irc->oconv != (GIConv) - 1) {
-		gsize bytes_read, bytes_written;
-		char *conv;
-
-		conv = g_convert_with_iconv(line, -1, irc->oconv,
-		                            &bytes_read, &bytes_written, NULL);
-
-		if (bytes_read == strlen(line)) {
-			strncpy(line, conv, IRC_MAX_LINE - 2);
-		}
-
-		g_free(conv);
-	}
-	g_strlcat(line, "\r\n", IRC_MAX_LINE + 1);
-
-	g_string_append(irc->sendbuffer, line);
-
-	if (irc->w_watch_source_id == 0) {
-		/* If the buffer is empty we can probably write, so call the write event handler
-		   immediately. If it returns TRUE, it should be called again, so add the event to
-		   the queue. If it's FALSE, we emptied the buffer and saved ourselves some work
-		   in the event queue. */
-		/* Really can't be done as long as the code doesn't do error checking very well:
-		if( bitlbee_io_current_client_write( irc, irc->fd, B_EV_IO_WRITE ) ) */
-
-		/* So just always do it via the event handler. */
-		irc->w_watch_source_id = b_input_add(irc->fd, B_EV_IO_WRITE, bitlbee_io_current_client_write, irc);
-	}
-
-	return;
-}
-
-/* Flush sendbuffer if you can. If it fails, fail silently and let some
-   I/O event handler clean up. */
-void irc_flush(irc_t *irc)
-{
-	ssize_t n;
-	size_t len = irc->sendbuffer->len;
-
-	if (len == 0) {
-		return;
-	}
-
-	if ((n = send(irc->fd, irc->sendbuffer->str, len, 0)) == len) {
-		g_string_truncate(irc->sendbuffer, 0);
-
-		b_event_remove(irc->w_watch_source_id);
-		irc->w_watch_source_id = 0;
-	} else if (n > 0) {
-		g_string_erase(irc->sendbuffer, 0, n);
-	}
-	/* Otherwise something went wrong and we don't currently care
-	   what the error was. We may or may not succeed later, we
-	   were just trying to flush the buffer immediately. */
-}
-
-/* Meant for takeover functionality. Transfer an IRC connection to a different
-   socket. */
-void irc_switch_fd(irc_t *irc, int fd)
-{
-	irc_write(irc, "ERROR :Transferring session to a new connection");
-	irc_flush(irc);   /* Write it now or forget about it forever. */
-
-	if (irc->sendbuffer) {
-		b_event_remove(irc->w_watch_source_id);
-		irc->w_watch_source_id = 0;
-		g_string_truncate(irc->sendbuffer, 0);
-	}
-
-	b_event_remove(irc->r_watch_source_id);
-	closesocket(irc->fd);
-	irc->fd = fd;
-	irc->r_watch_source_id = b_input_add(irc->fd, B_EV_IO_READ, bitlbee_io_current_client_read, irc);
-}
-
-void irc_sync(irc_t *irc)
-{
-	GSList *l;
-
-	irc_write(irc, ":%s!%s@%s MODE %s :+%s", irc->user->nick,
-	          irc->user->user, irc->user->host, irc->user->nick,
-	          irc->umode);
-
-	for (l = irc->channels; l; l = l->next) {
-		irc_channel_t *ic = l->data;
-		if (ic->flags & IRC_CHANNEL_JOINED) {
-			irc_send_join(ic, irc->user);
-		}
-	}
-
-	/* We may be waiting for a PONG from the previous client connection. */
-	irc->pinging = FALSE;
-}
-
-void irc_desync(irc_t *irc)
-{
-	GSList *l;
-
-	for (l = irc->channels; l; l = l->next) {
-		irc_channel_del_user(l->data, irc->user, IRC_CDU_KICK,
-		                     "Switching to old session");
-	}
-
-	irc_write(irc, ":%s!%s@%s MODE %s :-%s", irc->user->nick,
-	          irc->user->user, irc->user->host, irc->user->nick,
-	          irc->umode);
-}
-
-int irc_check_login(irc_t *irc)
-{
-	if (irc->user->user && irc->user->nick && !(irc->status & USTATUS_CAP_PENDING)) {
-		if (global.conf->authmode == AUTHMODE_CLOSED && !(irc->status & USTATUS_AUTHORIZED)) {
-			irc_send_num(irc, 464, ":This server is password-protected.");
-			return 0;
-		} else {
-			irc_channel_t *ic;
-			irc_user_t *iu = irc->user;
-
-			irc->user = irc_user_new(irc, iu->nick);
-			irc->user->user = iu->user;
-			irc->user->host = iu->host;
-			irc->user->fullname = iu->fullname;
-			irc->user->f = &irc_user_self_funcs;
-			g_free(iu->nick);
-			g_free(iu);
-
-			if (global.conf->runmode == RUNMODE_FORKDAEMON || global.conf->runmode == RUNMODE_DAEMON) {
-				ipc_to_master_str("CLIENT %s %s :%s\r\n", irc->user->host, irc->user->nick,
-				                  irc->user->fullname);
-			}
-
-			irc->status |= USTATUS_LOGGED_IN;
-
-			irc_send_login(irc);
-
-			irc->umode[0] = '\0';
-			irc_umode_set(irc, "+" UMODE, TRUE);
-
-			ic = irc->default_channel = irc_channel_new(irc, ROOT_CHAN);
-			irc_channel_set_topic(ic, CONTROL_TOPIC, irc->root);
-			set_setstr(&ic->set, "auto_join", "true");
-			irc_channel_auto_joins(irc, NULL);
-
-			irc->root->last_channel = irc->default_channel;
-
-			irc_rootmsg(irc,
-			            "Welcome to the BitlBee gateway!\n\n"
-			            "Running %s %s\n\n"
-			            "If you've never used BitlBee before, please do read the help "
-			            "information using the \x02help\x02 command. Lots of FAQs are "
-			            "answered there.\n"
-			            "If you already have an account on this server, just use the "
-			            "\x02identify\x02 command to identify yourself.",
-			            PACKAGE, BITLBEE_VERSION);
-
-			/* This is for bug #209 (use PASS to identify to NickServ). */
-			if (irc->password != NULL) {
-				char *send_cmd[] = { "identify", g_strdup(irc->password), NULL };
-
-				irc_setpass(irc, NULL);
-				root_command(irc, send_cmd);
-				g_free(send_cmd[1]);
-			}
-
-			return 1;
-		}
-	} else {
-		/* More information needed. */
-		return 0;
-	}
-}
-
-/* TODO: This is a mess, but this function is a bit too complicated to be
-   converted to something more generic. */
-void irc_umode_set(irc_t *irc, const char *s, gboolean allow_priv)
-{
-	/* allow_priv: Set to 0 if s contains user input, 1 if you want
-	   to set a "privileged" mode (+o, +R, etc). */
-	char m[128], st = 1;
-	const char *t;
+	int control = ( g_strcasecmp( channel, irc->channel ) == 0 );
+	struct conversation *c = NULL;
+	
+	if( !control )
+		c = conv_findchannel( channel );
+	
+	/* RFC's say there is no error reply allowed on NAMES, so when the
+	   channel is invalid, just give an empty reply. */
+	
+	if( control || c ) while( u )
+	{
+		if( u->online )
+		{
+			if( u->gc && control )
+			{
+				if( set_getint( irc, "away_devoice" ) && !u->away )
+					s = "+";
+				else
+					s = "";
+				
+				irc_reply( irc, 353, "@ %s :%s%s", channel, s, u->nick );
+			}
+			else if( !u->gc )
+			{
+				if( strcmp( u->nick, irc->mynick ) == 0 && ( strcmp( set_getstr( irc, "ops" ), "root" ) == 0 || strcmp( set_getstr( irc, "ops" ), "both" ) == 0 ) )
+					s = "@";
+				else if( strcmp( u->nick, irc->nick ) == 0 && ( strcmp( set_getstr( irc, "ops" ), "user" ) == 0 || strcmp( set_getstr( irc, "ops" ), "both" ) == 0 ) )
+					s = "@";
+				else
+					s = "";
+				
+				irc_reply( irc, 353, "@ %s :%s%s", channel, s, u->nick );
+			}
+		}
+		
+		u = u->next;
+	}
+	
+	/* For non-controlchannel channels (group conversations) only root and
+	   you are listed now. Time to show the channel people: */
+	if( !control && c )
+	{
+		GList *l;
+		
+		for( l = c->in_room; l; l = l->next )
+			if( ( u = user_findhandle( c->gc, l->data ) ) )
+				irc_reply( irc, 353, "@ %s :%s%s", channel, "", u->nick );
+	}
+	
+	irc_reply( irc, 366, "%s :End of /NAMES list", channel );
+}
+
+void irc_who( irc_t *irc, char *channel )
+{
+	user_t *u = irc->users;
+	struct conversation *c;
+	GList *l;
+	
+	if( !channel || *channel == '0' || *channel == '*' || !*channel )
+		while( u )
+		{
+			irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", u->online ? irc->channel : "*", u->user, u->host, irc->myhost, u->nick, u->online ? ( u->away ? 'G' : 'H' ) : 'G', u->realname );
+			u = u->next;
+		}
+	else if( g_strcasecmp( channel, irc->channel ) == 0 )
+		while( u )
+		{
+			if( u->online )
+				irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", channel, u->user, u->host, irc->myhost, u->nick, u->away ? 'G' : 'H', u->realname );
+			u = u->next;
+		}
+	else if( ( c = conv_findchannel( channel ) ) )
+		for( l = c->in_room; l; l = l->next )
+		{
+			if( ( u = user_findhandle( c->gc, l->data ) ) )
+				irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", channel, u->user, u->host, irc->myhost, u->nick, u->away ? 'G' : 'H', u->realname );
+		}
+	else if( ( u = user_find( irc, channel ) ) )
+		irc_reply( irc, 352, "%s %s %s %s %s %c :0 %s", channel, u->user, u->host, irc->myhost, u->nick, u->online ? ( u->away ? 'G' : 'H' ) : 'G', u->realname );
+	
+	irc_reply( irc, 315, "%s :End of /WHO list.", channel?channel:"**" );
+}
+
+void irc_login( irc_t *irc )
+{
+	user_t *u;
+	
+	irc_reply( irc,   1, ":Welcome to the BitlBee gateway, %s", irc->nick );
+	irc_reply( irc,   2, ":Host %s is running BitlBee " BITLBEE_VERSION " " ARCH "/" CPU ".", irc->myhost );
+	irc_reply( irc,   3, ":%s", IRCD_INFO );
+	irc_reply( irc,   4, "%s %s %s %s", irc->myhost, BITLBEE_VERSION, UMODES, CMODES );
+	irc_motd( irc );
+	irc_umode_set( irc, irc->myhost, "+" UMODE );
+
+	u = user_add( irc, irc->mynick );
+	u->host = g_strdup( irc->myhost );
+	u->realname = g_strdup( ROOT_FN );
+	u->online = 1;
+	u->send_handler = root_command_string;
+	u->is_private = 0; /* [SH] The channel is root's personal playground. */
+	irc_spawn( irc, u );
+	
+	u = user_add( irc, NS_NICK );
+	u->host = g_strdup( irc->myhost );
+	u->realname = g_strdup( ROOT_FN );
+	u->online = 0;
+	u->send_handler = root_command_string;
+	u->is_private = 1; /* [SH] NickServ is not in the channel, so should always /query. */
+	
+	u = user_add( irc, irc->nick );
+	u->user = g_strdup( irc->user );
+	u->host = g_strdup( irc->host );
+	u->realname = g_strdup( irc->realname );
+	u->online = 1;
+//	u->send_handler = msg_echo;
+	irc_spawn( irc, u );
+	
+	irc_usermsg( irc, "Welcome to the BitlBee gateway!\n\nIf you've never used BitlBee before, please do read the help information using the help command. Lots of FAQ's are answered there." );
+	
+	irc->status = USTATUS_LOGGED_IN;
+}
+
+void irc_motd( irc_t *irc )
+{
+	int fd;
+	
+	fd = open( global.conf->motdfile, O_RDONLY );
+	if( fd == -1 )
+	{
+		irc_reply( irc, 422, ":We don't need MOTDs." );
+	}
+	else
+	{
+		char linebuf[80];	/* Max. line length for MOTD's is 79 chars. It's what most IRC networks seem to do. */
+		char *add, max;
+		int len;
+		
+		linebuf[79] = len = 0;
+		max = sizeof( linebuf ) - 1;
+		
+		irc_reply( irc, 375, ":- %s Message Of The Day - ", irc->myhost );
+		while( read( fd, linebuf + len, 1 ) == 1 )
+		{
+			if( linebuf[len] == '\n' || len == max )
+			{
+				linebuf[len] = 0;
+				irc_reply( irc, 372, ":- %s", linebuf );
+				len = 0;
+			}
+			else if( linebuf[len] == '%' )
+			{
+				read( fd, linebuf + len, 1 );
+				if( linebuf[len] == 'h' )
+					add = irc->myhost;
+				else if( linebuf[len] == 'v' )
+					add = BITLBEE_VERSION;
+				else if( linebuf[len] == 'n' )
+					add = irc->nick;
+				else
+					add = "%";
+				
+				strncpy( linebuf + len, add, max - len );
+				while( linebuf[++len] );
+			}
+			else if( len < max )
+			{
+				len ++;
+			}
+		}
+		irc_reply( irc, 376, ":End of MOTD" );
+		closesocket( fd );
+	}
+}
+
+void irc_topic( irc_t *irc, char *channel )
+{
+	if( g_strcasecmp( channel, irc->channel ) == 0 )
+	{
+		irc_reply( irc, 332, "%s :%s", channel, CONTROL_TOPIC );
+	}
+	else
+	{
+		struct conversation *c = conv_findchannel( channel );
+		
+		if( c )
+			irc_reply( irc, 332, "%s :BitlBee groupchat: \"%s\". Please keep in mind that root-commands won't work here. Have fun!", channel, c->title );
+		else
+			irc_reply( irc, 331, "%s :No topic for this channel" );
+	}
+}
+
+void irc_whois( irc_t *irc, char *nick )
+{
+	user_t *u = user_find( irc, nick );
+	
+	if( u )
+	{
+		irc_reply( irc, 311, "%s %s %s * :%s", u->nick, u->user, u->host, u->realname );
+		
+		if( u->gc )
+			irc_reply( irc, 312, "%s %s.%s :%s network", u->nick, u->gc->user->username,
+			           *u->gc->user->proto_opt[0] ? u->gc->user->proto_opt[0] : "", proto_name[u->gc->user->protocol] );
+		else
+			irc_reply( irc, 312, "%s %s :%s", u->nick, irc->myhost, IRCD_INFO );
+		
+		if( !u->online )
+			irc_reply( irc, 301, "%s :%s", u->nick, "User is offline" );
+		else if( u->away )
+			irc_reply( irc, 301, "%s :%s", u->nick, u->away );
+		
+		irc_reply( irc, 318, "%s :End of /WHOIS list", nick );
+	}
+	else
+	{
+		irc_reply( irc, 401, "%s :Nick does not exist", nick );
+	}
+}
+
+
+void irc_umode_set( irc_t *irc, char *who, char *s )
+{
+	char m[256], st = 1, *t;
 	int i;
-	char changes[512], st2 = 2;
-	char badflag = 0;
-
-	memset(m, 0, sizeof(m));
-
-	/* Keep track of which modes are enabled in this array. */
-	for (t = irc->umode; *t; t++) {
-		if (*t < sizeof(m)) {
-			m[(int) *t] = 1;
-		}
-	}
-
-	i = 0;
-	for (t = s; *t && i < sizeof(changes) - 3; t++) {
-		if (*t == '+' || *t == '-') {
+	
+	memset( m, 0, sizeof( m ) );
+	
+	for( t = irc->umode; *t; t ++ )
+		m[(int)*t] = 1;
+	
+	for( t = s; *t; t ++ )
+	{
+		if( *t == '+' || *t == '-' )
 			st = *t == '+';
-		} else if ((st == 0 && (!strchr(UMODES_KEEP, *t) || allow_priv)) ||
-		           (st == 1 && strchr(UMODES, *t)) ||
-		           (st == 1 && allow_priv && strchr(UMODES_PRIV, *t))) {
-			if (m[(int) *t] != st) {
-				/* If we're actually making a change, remember this
-				   for the response. */
-				if (st != st2) {
-					st2 = st, changes[i++] = st ? '+' : '-';
+		else
+			m[(int)*t] = st;
+	}
+	
+	memset( irc->umode, 0, sizeof( irc->umode ) );
+	
+	for( i = 0; i < 256 && strlen( irc->umode ) < ( sizeof( irc->umode ) - 1 ); i ++ )
+		if( m[i] && strchr( UMODES, i ) )
+			irc->umode[strlen(irc->umode)] = i;
+	
+	irc_reply( irc, 221, "+%s", irc->umode );
+}
+
+int irc_away( irc_t *irc, char *away )
+{
+	user_t *u = user_find( irc, irc->nick );
+	GSList *c = get_connections();
+	
+	if( !u ) return( 0 );
+	
+	if( away && *away )
+	{
+		int i, j;
+		
+		/* Copy away string, but skip control chars. Mainly because
+		   Jabber really doesn't like them. */
+		u->away = g_malloc( strlen( away ) + 1 );
+		for( i = j = 0; away[i]; i ++ )
+			if( ( u->away[j] = away[i] ) >= ' ' )
+				j ++;
+		u->away[j] = 0;
+		
+		irc_reply( irc, 306, ":You're now away: %s", u->away );
+		/* irc_umode_set( irc, irc->myhost, "+a" ); */
+	}
+	else
+	{
+		if( u->away ) g_free( u->away );
+		u->away = NULL;
+		/* irc_umode_set( irc, irc->myhost, "-a" ); */
+		irc_reply( irc, 305, ":Welcome back" );
+	}
+	
+	while( c )
+	{
+		if( ((struct gaim_connection *)c->data)->flags & OPT_LOGGED_IN )
+			proto_away( c->data, u->away );
+		
+		c = c->next;
+	}
+	
+	return( 1 );
+}
+
+void irc_spawn( irc_t *irc, user_t *u )
+{
+	irc_join( irc, u, irc->channel );
+}
+
+void irc_join( irc_t *irc, user_t *u, char *channel )
+{
+	char *nick;
+	
+	if( ( g_strcasecmp( channel, irc->channel ) != 0 ) || user_find( irc, irc->nick ) )
+		irc_write( irc, ":%s!%s@%s JOIN :%s", u->nick, u->user, u->host, channel );
+	
+	if( nick_cmp( u->nick, irc->nick ) == 0 )
+	{
+		irc_write( irc, ":%s MODE %s +%s", irc->myhost, channel, CMODE );
+		irc_names( irc, channel );
+		irc_topic( irc, channel );
+	}
+	
+	nick = g_strdup( u->nick );
+	nick_lc( nick );
+	if( g_hash_table_lookup( irc->watches, nick ) )
+	{
+		irc_reply( irc, 600, "%s %s %s %d :%s", u->nick, u->user, u->host, time( NULL ), "logged online" );
+	}
+	g_free( nick );
+}
+
+void irc_part( irc_t *irc, user_t *u, char *channel )
+{
+	irc_write( irc, ":%s!%s@%s PART %s :%s", u->nick, u->user, u->host, channel, "" );
+}
+
+void irc_kick( irc_t *irc, user_t *u, char *channel, user_t *kicker )
+{
+	irc_write( irc, ":%s!%s@%s KICK %s %s :%s", kicker->nick, kicker->user, kicker->host, channel, u->nick, "" );
+}
+
+void irc_kill( irc_t *irc, user_t *u )
+{
+	char *nick;
+	
+	irc_write( irc, ":%s!%s@%s QUIT :%s", u->nick, u->user, u->host, "Leaving..." );
+	
+	nick = g_strdup( u->nick );
+	nick_lc( nick );
+	if( g_hash_table_lookup( irc->watches, nick ) )
+	{
+		irc_reply( irc, 601, "%s %s %s %d :%s", u->nick, u->user, u->host, time( NULL ), "logged offline" );
+	}
+	g_free( nick );
+}
+
+void irc_invite( irc_t *irc, char *nick, char *channel )
+{
+	struct conversation *c = conv_findchannel( channel );
+	user_t *u = user_find( irc, nick );
+	
+	if( u && c && ( u->gc == c->gc ) )
+		if( c->gc && c->gc->prpl && c->gc->prpl->chat_invite )
+		{
+			c->gc->prpl->chat_invite( c->gc, c->id, "", u->handle );
+			irc_reply( irc, 341, "%s %s", nick, channel );
+			return;
+		}
+	
+	irc_reply( irc, 482, "%s :Invite impossible; User/Channel non-existent or incompatible", channel );
+}
+
+int irc_send( irc_t *irc, char *nick, char *s, int flags )
+{
+	struct conversation *c = NULL;
+	user_t *u = NULL;
+	
+	if( *nick == '#' )
+	{
+		if( !( c = conv_findchannel( nick ) ) )
+		{
+			irc_reply( irc, 403, "%s :Channel does not exist", nick );
+			return( 0 );
+		}
+	}
+	else
+	{
+		u = user_find( irc, nick );
+		
+		if( !u )
+		{
+			if( irc->is_private )
+				irc_reply( irc, 401, "%s :Nick does not exist", nick );
+			else
+				irc_usermsg( irc, "Nick `%s' does not exist!", nick );
+			return( 0 );
+		}
+	}
+	
+	if( *s == 1 && s[strlen(s)-1] == 1 )
+	{
+		if( g_strncasecmp( s + 1, "ACTION", 6 ) == 0 )
+		{
+			if( s[7] == ' ' ) s ++;
+			s += 3;
+			*(s++) = '/';
+			*(s++) = 'm';
+			*(s++) = 'e';
+			*(s++) = ' ';
+			s -= 4;
+			s[strlen(s)-1] = 0;
+		}
+		else if( g_strncasecmp( s + 1, "VERSION", 7 ) == 0 )
+		{
+			u = user_find( irc, irc->mynick );
+			irc_privmsg( irc, u, "NOTICE", irc->nick, "", "\001VERSION BitlBee " BITLBEE_VERSION " " ARCH "/" CPU "\001" );
+			return( 1 );
+		}
+		else if( g_strncasecmp( s + 1, "PING", 4 ) == 0 )
+		{
+			u = user_find( irc, irc->mynick );
+			irc_privmsg( irc, u, "NOTICE", irc->nick, "", s );
+			return( 1 );
+		}
+		else if( g_strncasecmp( s + 1, "TYPING", 6 ) == 0 )
+		{
+			if( u && u->gc && u->gc->prpl->send_typing && strlen( s ) >= 10 )
+			{
+				time_t current_typing_notice = time( NULL );
+				
+				if( current_typing_notice - u->last_typing_notice >= 5 )
+				{
+					u->gc->prpl->send_typing( u->gc, u->handle, s[8] == '1' );
+					u->last_typing_notice = current_typing_notice;
 				}
-				changes[i++] = *t;
-			}
-			m[(int) *t] = st;
-		} else {
-			badflag = 1;
-		}
-	}
-	changes[i] = '\0';
-
-	/* Convert the m array back into an umode string. */
-	memset(irc->umode, 0, sizeof(irc->umode));
-	for (i = 'A'; i <= 'z' && strlen(irc->umode) < (sizeof(irc->umode) - 1); i++) {
-		if (m[i]) {
-			irc->umode[strlen(irc->umode)] = i;
-		}
-	}
-
-	if (badflag) {
-		irc_send_num(irc, 501, ":Unknown MODE flag");
-	}
-	if (*changes) {
-		irc_write(irc, ":%s!%s@%s MODE %s :%s", irc->user->nick,
-		          irc->user->user, irc->user->host, irc->user->nick,
-		          changes);
-	}
+			}
+			return( 1 );
+		}
+		else
+		{
+			irc_usermsg( irc, "Non-ACTION CTCP's aren't supported" );
+			return( 0 );
+		}
+	}
+	
+	if( u )
+	{
+		/* For the next message, we probably do have to send new notices... */
+		u->last_typing_notice = 0;
+		u->is_private = irc->is_private;
+		
+		if( u->is_private )
+		{
+			if( !u->online )
+				irc_reply( irc, 301, "%s :%s", u->nick, "User is offline" );
+			else if( u->away )
+				irc_reply( irc, 301, "%s :%s", u->nick, u->away );
+		}
+		
+		if( u->send_handler )
+			return( u->send_handler( irc, u, s, flags ) );
+	}
+	else if( c && c->gc && c->gc->prpl )
+	{
+		return( serv_send_chat( irc, c->gc, c->id, s ) );
+	}
+	
+	return( 0 );
+}
+
+gboolean buddy_send_handler_delayed( gpointer data )
+{
+	user_t *u = data;
+	
+	u->sendbuf[u->sendbuf_len-2] = 0; /* Cut off the last newline */
+	serv_send_im( u->gc->irc, u, u->sendbuf, u->sendbuf_flags );
+	
+	g_free( u->sendbuf );
+	u->sendbuf = NULL;
+	u->sendbuf_len = 0;
+	u->sendbuf_timer = 0;
+	u->sendbuf_flags = 0;
+	
+	return( FALSE );
+}
+
+int buddy_send_handler( irc_t *irc, user_t *u, char *msg, int flags )
+{
+	if( !u || !u->gc ) return( 0 );
+	
+	if( set_getint( irc, "buddy_sendbuffer" ) && set_getint( irc, "buddy_sendbuffer_delay" ) > 0 )
+	{
+		if( u->sendbuf_len > 0 && u->sendbuf_flags != flags)
+		{
+			//Flush the buffer
+			g_source_remove( u->sendbuf_timer );
+			buddy_send_handler_delayed( u );
+		}
+
+		if( u->sendbuf_len == 0 )
+		{
+			u->sendbuf_len = strlen( msg ) + 2;
+			u->sendbuf = g_new (char, u->sendbuf_len );
+			u->sendbuf[0] = 0;
+			u->sendbuf_flags = flags;
+		}
+		else
+		{
+			u->sendbuf_len += strlen( msg ) + 1;
+			u->sendbuf = g_renew ( char, u->sendbuf, u->sendbuf_len );
+		}
+		
+		strcat( u->sendbuf, msg );
+		strcat( u->sendbuf, "\n" );
+		
+		if( u->sendbuf_timer > 0 )
+			g_source_remove( u->sendbuf_timer );
+		u->sendbuf_timer = g_timeout_add( set_getint( irc, "buddy_sendbuffer_delay" ) * 1000,
+		                                  buddy_send_handler_delayed, u );
+		
+		return( 1 );
+	}
+	else
+	{
+		return( serv_send_im( irc, u, msg, flags ) );
+	}
+}
+
+int irc_privmsg( irc_t *irc, user_t *u, char *type, char *to, char *prefix, char *msg )
+{
+	char last = 0;
+	char *s = msg, *line = msg;
+	
+	/* The almighty linesplitter .. woohoo!! */
+	while( !last )
+	{
+		if( *s == '\r' && *(s+1) == '\n' )
+			*(s++) = 0;
+		if( *s == '\n' )
+		{
+			last = s[1] == 0;
+			*s = 0;
+		}
+		else
+		{
+			last = s[0] == 0;
+		}
+		if( *s == 0 )
+		{
+			if( g_strncasecmp( line, "/me ", 4 ) == 0 && ( !prefix || !*prefix ) && g_strcasecmp( type, "PRIVMSG" ) == 0 )
+			{
+				irc_write( irc, ":%s!%s@%s %s %s :\001ACTION %s\001", u->nick, u->user, u->host,
+				           type, to, line + 4 );
+			}
+			else
+			{
+				irc_write( irc, ":%s!%s@%s %s %s :%s%s", u->nick, u->user, u->host,
+				           type, to, prefix, line );
+			}
+			line = s + 1;
+		}
+		s ++;
+	}
+	
+	return( 1 );
+}
+
+int irc_msgfrom( irc_t *irc, char *nick, char *msg )
+{
+	user_t *u = user_find( irc, nick );
+	static char *prefix = NULL;
+	
+	if( !u ) return( 0 );
+	if( prefix && *prefix ) g_free( prefix );
+	
+	if( !u->is_private && nick_cmp( u->nick, irc->mynick ) != 0 )
+	{
+		int len = strlen( irc->nick) + 3;
+		prefix = g_new (char, len );
+		g_snprintf( prefix, len, "%s%s", irc->nick, set_getstr( irc, "to_char" ) );
+		prefix[len-1] = 0;
+	}
+	else
+	{
+		prefix = "";
+	}
+	
+	return( irc_privmsg( irc, u, "PRIVMSG", u->is_private ? irc->nick : irc->channel, prefix, msg ) );
+}
+
+int irc_noticefrom( irc_t *irc, char *nick, char *msg )
+{
+	user_t *u = user_find( irc, nick );
+	
+	if( u )
+		return( irc_privmsg( irc, u, "NOTICE", irc->nick, "", msg ) );
+	else
+		return( 0 );
 }
 
